image: zenika/alpine-maven:3-jdk8

variables:
  MAVEN_CLI_OPTS: "-s settings.xml --batch-mode"
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"
  RELEASE_FROM_BRANCH: 'master'

cache:
  paths:
    - .m2/repository/
    - target/

stages:
  - code-compile
  - upload-artifacts

.setup-git: &setup-git
  - 'apk add --update -y bash openssh-client git'
  - eval $(ssh-agent -s)
  - mkdir -p ~/.ssh && chmod 700 ~/.ssh
  - echo "$SSH_KEY" > ~/.ssh/id_rsa && chmod 600 ~/.ssh/id_rsa
  - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
  - chmod 600 ~/.ssh/config
  - git config --global user.name $GITLAB_USER_NAME
  - git config --global user.email $GITLAB_USER_EMAIL


.checkout-release-from: &checkout-release-from
  -  git fetch --all
  -  git checkout ${RELEASE_FROM_BRANCH}

.calculate-version-info: &calculate-version-info
  - #determine current patch version
    patch=$(echo -e $CI_COMMIT_TAG  | sed -r 's/.+\.(\d+)\.(RELEASE|M\d+|RC\d+)$/\1/'); echo patch=${patch}
  - #increment patch if release
    echo $CI_COMMIT_TAG | grep -q '\.RELEASE$' && patch=$((patch +1)); echo new path=${patch}
  - 'nextVersion=$(echo $CI_COMMIT_TAG | sed -r "s/v(\d+)\.(\d+)\.(\d+)\..+/\1.\2\.${patch}-SNAPSHOT/"); echo nextVersion: $nextVersion'
  - 'releaseVersion=${CI_COMMIT_TAG:1}; echo releaseVersion: ${releaseVersion}'
  - 'tagByMvn=${CI_COMMIT_TAG}-tbm; echo tagByMvn: ${tagByMvn}'

.move-tag: &move-tag
  - 'sha1ForTagByMvn=$(git show-ref -s ${tagByMvn})'
  - 'git tag --force ${CI_COMMIT_TAG} ${sha1ForTagByMvn}'
  - echo $CI_REPOSITORY_URL | sed -r 's/^.+gitlab.com\//git@gitlab.com:/'
  - git remote set-url --push origin "$(echo $CI_REPOSITORY_URL | sed -r 's/^.+gitlab.com\//git@gitlab.com:/')"
  - 'git push --force --tags'
  - git push --delete origin ${tagByMvn}

code-compile:
  stage: code-compile
  script: mvn clean compile
  rules:
    - when: always

upload-artifacts:
  stage: upload-artifacts
  before_script:
    - *setup-git
  script:
    - 'bash -e'
    - *checkout-release-from
    - *calculate-version-info
    - 'mvn $MAVEN_CLI_OPTS -Dtag=${tagByMvn} -DreleaseVersion=${releaseVersion} -DdevelopmentVersion=${nextVersion} release:prepare release:perform'
    - *move-tag
  rules:
    - if: '$CI_COMMIT_TAG =~ /^v(\d+\.){3}(RELEASE|M[1-9]+|RC[1-9]+)$/'
      when: always
    - when: never

